// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/driver/hpdi32cos.h $
// $Rev: 54401 $
// $Date: 2024-05-02 09:37:04 -0500 (Thu, 02 May 2024) $

// HPDI32-COS: Device Driver: header file

#ifndef	__HPDI32COS_H__
#define	__HPDI32COS_H__

#include "gsc_common.h"
#include "gsc_pci9080.h"



// macros *********************************************************************

#define	HPDI32COS_BASE_NAME					"hpdi32cos"

// IOCTL command codes
#define	HPDI32COS_IOCTL_REG_READ			OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	HPDI32COS_IOCTL_REG_WRITE			OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	HPDI32COS_IOCTL_REG_MOD				OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	HPDI32COS_IOCTL_QUERY				OS_IOCTL_RW( 3,  4, s32)
#define	HPDI32COS_IOCTL_INITIALIZE			OS_IOCTL   ( 4)
#define	HPDI32COS_IOCTL_BYTE_ENABLE			OS_IOCTL_RW( 5,  4, s32)
#define	HPDI32COS_IOCTL_CC_D0_D6_STATE		OS_IOCTL_R ( 6,  4, s32)
#define	HPDI32COS_IOCTL_CC_D5_D6			OS_IOCTL_RW( 7,  4, s32)
#define	HPDI32COS_IOCTL_CLOCK_DIVIDER		OS_IOCTL_RW( 8,  4, s32)
#define	HPDI32COS_IOCTL_COS_DETECTED		OS_IOCTL_RW( 9,  4, s32)
#define	HPDI32COS_IOCTL_COUNTER_ZERO		OS_IOCTL_R (10,  4, s32)
#define	HPDI32COS_IOCTL_EVENT_COUNT			OS_IOCTL_R (11,  4, u32)
#define	HPDI32COS_IOCTL_EVNT_CNT_INI_GET	OS_IOCTL_R (12,  4, u32)
#define	HPDI32COS_IOCTL_EVNT_CNT_INI_SET	OS_IOCTL_W (13,  4, u32)
#define	HPDI32COS_IOCTL_FIFO_WORD_COUNT		OS_IOCTL_R (14,  4, u32)
#define	HPDI32COS_IOCTL_IRQ_CONFIG_EDGE		OS_IOCTL_RW(15,  4, s32)
#define	HPDI32COS_IOCTL_IRQ_CONFIG_HIGH		OS_IOCTL_RW(16,  4, s32)
#define	HPDI32COS_IOCTL_IRQ_ENABLE			OS_IOCTL_RW(17,  4, s32)
#define	HPDI32COS_IOCTL_LA_TRIG_WORD_GET	OS_IOCTL_R (18,  4, u32)
#define	HPDI32COS_IOCTL_LA_TRIG_WORD_SET	OS_IOCTL_W (19,  4, u32)
#define	HPDI32COS_IOCTL_LA_TRIGGERED		OS_IOCTL_RW(20,  4, s32)
#define	HPDI32COS_IOCTL_LOOPBACK			OS_IOCTL_RW(21,  4, s32)
#define	HPDI32COS_IOCTL_MODE				OS_IOCTL_RW(22,  4, s32)
#define	HPDI32COS_IOCTL_RX_DATA				OS_IOCTL_R (23,  4, u32)
#define	HPDI32COS_IOCTL_RX_DATA_MASK_GET	OS_IOCTL_R (24,  4, u32)
#define	HPDI32COS_IOCTL_RX_DATA_MASK_SET	OS_IOCTL_W (25,  4, u32)
#define	HPDI32COS_IOCTL_RX_FIFO_AE			OS_IOCTL_RW(26,  4, s32)
#define	HPDI32COS_IOCTL_RX_FIFO_AF			OS_IOCTL_RW(27,  4, s32)
#define	HPDI32COS_IOCTL_RX_FIFO_OVER		OS_IOCTL_RW(28,  4, s32)
#define	HPDI32COS_IOCTL_RX_FIFO_RESET		OS_IOCTL   (29)
#define	HPDI32COS_IOCTL_RX_FIFO_STATUS		OS_IOCTL_R (30,  4, s32)
#define	HPDI32COS_IOCTL_RX_FIFO_UNDER		OS_IOCTL_RW(31,  4, s32)
#define	HPDI32COS_IOCTL_RX_IO_ABORT			OS_IOCTL_R (32,  4, s32)
#define	HPDI32COS_IOCTL_RX_IO_BMDMA_TRSH	OS_IOCTL_RW(33,  4, s32)
#define	HPDI32COS_IOCTL_RX_IO_MODE			OS_IOCTL_RW(34,  4, s32)
#define	HPDI32COS_IOCTL_RX_IO_OVER			OS_IOCTL_RW(35,  4, s32)
#define	HPDI32COS_IOCTL_RX_IO_PIO_TRSH		OS_IOCTL_RW(36,  4, s32)
#define	HPDI32COS_IOCTL_RX_IO_TIMEOUT		OS_IOCTL_RW(37,  4, s32)
#define	HPDI32COS_IOCTL_RX_IO_UNDER			OS_IOCTL_RW(38,  4, s32)
#define	HPDI32COS_IOCTL_RX_START			OS_IOCTL_RW(39,  4, s32)
#define	HPDI32COS_IOCTL_RX_STATE			OS_IOCTL_R (40,  4, s32)
#define	HPDI32COS_IOCTL_RX_WORD_COUNT		OS_IOCTL_R (41,  4, u32)
#define	HPDI32COS_IOCTL_TX_DATA_GET			OS_IOCTL_R (42,  4, u32)
#define	HPDI32COS_IOCTL_TX_DATA_SET			OS_IOCTL_W (43,  4, u32)
#define	HPDI32COS_IOCTL_TX_ENABLE			OS_IOCTL_RW(44,  4, s32)
#define	HPDI32COS_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(45, 28, gsc_wait_t)
#define	HPDI32COS_IOCTL_WAIT_EVENT			OS_IOCTL_RW(46, 28, gsc_wait_t)
#define	HPDI32COS_IOCTL_WAIT_STATUS			OS_IOCTL_RW(47, 28, gsc_wait_t)

//*****************************************************************************
// HPDI32COS_IOCTL_REG_READ
// HPDI32COS_IOCTL_REG_WRITE
// HPDI32COS_IOCTL_REG_MOD
//
#define	HPDI32COS_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	HPDI32COS_GSC_FRR					HPDI32COS_REG_ENCODE(4,0x00)// Firmware Revision Register
#define	HPDI32COS_GSC_BCR					HPDI32COS_REG_ENCODE(4,0x04)// Board Control Register
#define	HPDI32COS_GSC_BSR					HPDI32COS_REG_ENCODE(4,0x08)// Board Status Register
#define	HPDI32COS_GSC_ECR					HPDI32COS_REG_ENCODE(4,0x0C)// Event Counter Register
#define	HPDI32COS_GSC_RAR					HPDI32COS_REG_ENCODE(4,0x10)// Rx Almost Register
#define	HPDI32COS_GSC_SCDR					HPDI32COS_REG_ENCODE(4,0x14)// Sample Clock Divider Register
#define	HPDI32COS_GSC_RDFR					HPDI32COS_REG_ENCODE(4,0x18)// Rx Data FIFO Register
#define	HPDI32COS_GSC_TDOR					HPDI32COS_REG_ENCODE(4,0x18)// Tx Data Output Register
#define	HPDI32COS_GSC_RDIR					HPDI32COS_REG_ENCODE(4,0x1C)// Rx Data Input Register
#define	HPDI32COS_GSC_LATR					HPDI32COS_REG_ENCODE(4,0x20)// Logic Analyzer Trigger Register
#define	HPDI32COS_GSC_DMR					HPDI32COS_REG_ENCODE(4,0x24)// Data Mask Register
#define	HPDI32COS_GSC_ECIVR					HPDI32COS_REG_ENCODE(4,0x28)// Event Counter Initial Value Register
#define	HPDI32COS_GSC_RWCR					HPDI32COS_REG_ENCODE(4,0x2C)// Rx Word Count Register
#define	HPDI32COS_GSC_ICR					HPDI32COS_REG_ENCODE(4,0x30)// Interrupt Control Register
#define	HPDI32COS_GSC_ISR					HPDI32COS_REG_ENCODE(4,0x34)// Interrupt Status Register
#define	HPDI32COS_GSC_RFSR					HPDI32COS_REG_ENCODE(4,0x44)// Rx FIFO Size Register
#define	HPDI32COS_GSC_RFWCR					HPDI32COS_REG_ENCODE(4,0x4C)// Rx FIFO Word Count Register
#define	HPDI32COS_GSC_IELR					HPDI32COS_REG_ENCODE(4,0x50)// Interrupt Edge/Level Register
#define	HPDI32COS_GSC_IHLR					HPDI32COS_REG_ENCODE(4,0x54)// Interrupt High/Low Register

//*****************************************************************************
// HPDI32COS_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	HPDI32COS_QUERY_CLOCK_DIV_MAX,		// TCDR D0-D15	Maximum divider value.
	HPDI32COS_QUERY_COUNT,				//				How many query options are supported?
	HPDI32COS_QUERY_DEVICE_TYPE,		//				From gsc_common.h.
	HPDI32COS_QUERY_FIFO_SIZE_RX,		// RFSR D0-D31	Rx FIFO depth in 32-bit samples. 0 = unknown.
	HPDI32COS_QUERY_FORM_FACTOR,		//				hpdi32cos_form_factor_t
	HPDI32COS_QUERY_FREF_DEFAULT,		//				20MHz
	HPDI32COS_QUERY_FREF_MAX,			//				32MHz
	HPDI32COS_QUERY_JUMPER_ON,			//				What value means jumper is present?
	HPDI32COS_QUERY_JUMPER_QTY,			//				How many user jumpers are supported?
	HPDI32COS_QUERY_JUMPER_VAL,			// BSR D16-D17	Value from jumpers.
	HPDI32COS_QUERY_MODEL,				//				hpdi32cos_model_t
	HPDI32COS_IOCTL_QUERY_LAST

} hpdi32cos_query_t;

#define	HPDI32COS_IOCTL_QUERY_ERROR			(-1)

//*****************************************************************************
// HPDI32COS_IOCTL_INITIALIZE				BCR D0
//
//	Parameter:	None

//*****************************************************************************
// HPDI32COS_IOCTL_BYTE_ENABLE				BCR D12-D15
//
//	Parameter:	s32*
//		Pass in any bitwise OR combination of the following,
//		-1 to read the current setting.
#define	HPDI32COS_BYTE_ENABLE_NONE			0x0	// default
#define	HPDI32COS_BYTE_ENABLE_D7_D0			0x1
#define	HPDI32COS_BYTE_ENABLE_D15_D8		0x2
#define	HPDI32COS_BYTE_ENABLE_D23_D16		0x4
#define	HPDI32COS_BYTE_ENABLE_D31_D24		0x8
#define	HPDI32COS_BYTE_ENABLE_ALL			0xF

//*****************************************************************************
// HPDI32COS_IOCTL_CC_D0_D6_STATE			BSR D0-D6
//
//	Parameter:	s32*
//		The value returned will be in the range of zero through 0x7F.

//*****************************************************************************
// HPDI32COS_IOCTL_CC_D5_D6					BCR D6
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32COS_CC_D5_D6_RW				0	// read/write, default
#define	HPDI32COS_CC_D5_D6_RO				1	// read-only

//*****************************************************************************
// HPDI32COS_IOCTL_CLOCK_DIVIDER			SCDR D0-D15
//
//	Parameter:	s32*
//		Pass in any value in the range from 0 to 0xFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HPDI32COS_IOCTL_COS_DETECTED				BSR D26
//
//	Parameter:	s32*
//		Vaid values suppied to the driver as as follows.
#define	HPDI32COS_COS_DETECTED_CHECK		(-1)
#define	HPDI32COS_COS_DETECTED_CLEAR		1
//		One of the below options is returned.
#define	HPDI32COS_COS_DETECTED_NO			0
#define	HPDI32COS_COS_DETECTED_YES			1

//*****************************************************************************
// HPDI32COS_IOCTL_COUNTER_ZERO				BSR D25
//
//	Parameter:	s32*
//		One of the below options is returned.
#define	HPDI32COS_COUNTER_ZERO_NO			0
#define	HPDI32COS_COUNTER_ZERO_YES			1

//*****************************************************************************
// HPDI32COS_IOCTL_EVENT_COUNT				ECR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range of zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_EVNT_CNT_INI_GET			ECIVR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range of zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_EVNT_CNT_INI_SET			ECIVR D0-D31
//
//	Parameter:	u32*
//		The value passed in can be any value in the inclusive range of
//		zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_FIFO_WORD_COUNT			RFWCR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the inclusive range of zero through
//		the size of the Rx FIFO.

//*****************************************************************************
// HPDI32COS_IOCTL_IRQ_CONFIG_EDGE			IELR
// HPDI32COS_IOCTL_IRQ_CONFIG_HIGH			IHLR
// HPDI32COS_IOCTL_IRQ_ENABLE				ICR
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting. The value -1 cal be passed in for the
//		SEL service to determine which options are selected.
#define	HPDI32COS_IRQ_CC1_RISE				0x00000001
#define	HPDI32COS_IRQ_CC1_FALL				0x00000002
#define	HPDI32COS_IRQ_CC2					0x00000004
#define	HPDI32COS_IRQ_CC3					0x00000008
#define	HPDI32COS_IRQ_CC4					0x00000010
#define	HPDI32COS_IRQ_CC5					0x00000020
#define	HPDI32COS_IRQ_CC6					0x00000040
#define	HPDI32COS_IRQ_RX_FIFO_EMPTY			0x00001000
#define	HPDI32COS_IRQ_RX_FIFO_AE			0x00002000
#define	HPDI32COS_IRQ_RX_FIFO_AF			0x00004000
#define	HPDI32COS_IRQ_RX_FIFO_FULL			0x00008000
#define	HPDI32COS_IRQ_RX_FIFO_UNDER			0x00010000
#define	HPDI32COS_IRQ_RX_FIFO_OVER			0x00020000
#define	HPDI32COS_IRQ_RX_STOPPED			0x00080000
#define	HPDI32COS_IRQ_LA_TRIGGERED			0x00100000
#define	HPDI32COS_IRQ_RX_RUNNING			0x00200000
#define	HPDI32COS_IRQ_EVENT_COUNT_ZERO		0x00400000
#define	HPDI32COS_IRQ_COS_DETECTED			0x00800000
#define	HPDI32COS_IRQ_ALL					0x00FBF07F

//*****************************************************************************
// HPDI32COS_IOCTL_LA_TRIG_WORD_GET			LATR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range of zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_LA_TRIG_WORD_SET			LATR D0-D31
//
//	Parameter:	u32*
//		The value passed in can be any value in the inclusive range of
//		zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_LA_TRIGGERED				BSR D23
//
//	Parameter:	s32*
//		Vaid values suppied to the driver as as follows.
#define	HPDI32COS_LA_TRIGGERED_CHECK		(-1)
//		One of the below options is returned.
#define	HPDI32COS_LA_TRIGGERED_NO			0
#define	HPDI32COS_LA_TRIGGERED_YES			1

//*****************************************************************************
// HPDI32COS_IOCTL_LOOPBACK					BCR D7
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32COS_LOOPBACK_DISABLE			0	// default
#define	HPDI32COS_LOOPBACK_ENABLE			1

//*****************************************************************************
// HPDI32COS_IOCTL_MODE						BCR D16
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32COS_MODE_COS					0	// default
#define	HPDI32COS_MODE_LA					1

//*****************************************************************************
// HPDI32COS_IOCTL_RX_DATA					RDIR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range of zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_RX_DATA_MASK_GET			DMR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range of zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_RX_DATA_MASK_SET			DMR D0-D31
//
//	Parameter:	u32*
//		The value passed in can be any value in the inclusive range of
//		zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_RX_FIFO_AE				RAR D0-D15
// HPDI32COS_IOCTL_RX_FIFO_AF				RAR D16-D31
//
//	Parameter:	s32*
//		Pass in any value in the range from 0 to 0xFFFF, or -1 to read the
//		current setting.

//*****************************************************************************
// HPDI32COS_IOCTL_RX_FIFO_OVER				BSR D20
// HPDI32COS_IOCTL_RX_FIFO_UNDER			BSR D19
//
//	Parameter:	s32*
//		Vaid values suppied to the driver as as follows.
#define	HPDI32COS_FIFO_ERROR_CHECK			(-1)
#define	HPDI32COS_FIFO_ERROR_CLEAR			1
//		Values returned are as follows.
#define	HPDI32COS_FIFO_ERROR_NO				0
#define	HPDI32COS_FIFO_ERROR_YES			1

//*****************************************************************************
// HPDI32COS_IOCTL_RX_FIFO_RESET			BCR D2
//
//	Parameter:	None

//*****************************************************************************
// HPDI32COS_IOCTL_RX_FIFO_STATUS			BSR D12-D15
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	HPDI32COS_FIFO_STATUS_EMPTY			0
#define	HPDI32COS_FIFO_STATUS_AE			1
#define	HPDI32COS_FIFO_STATUS_MEDIUM		2
#define	HPDI32COS_FIFO_STATUS_AF			3
#define	HPDI32COS_FIFO_STATUS_FULL			4

//*****************************************************************************
// HPDI32COS_IOCTL_RX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	HPDI32COS_IO_ABORT_NO				0
#define	HPDI32COS_IO_ABORT_YES				1

//*****************************************************************************
// HPDI32COS_IOCTL_RX_IO_BMDMA_TRSH
//
//	Parameter:	s32*
//		Pass in any non-negative value from zero to the FIFO size, or
//		-1 to read the current setting.
#define	HPDI32COS_RX_IO_BMDMA_THRESH_DEF	60	// bytes

//*****************************************************************************
// HPDI32COS_IOCTL_RX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	HPDI32COS_IO_MODE_DEFAULT			GSC_IO_MODE_DMDMA

//*****************************************************************************
// HPDI32COS_IOCTL_RX_IO_OVER
// HPDI32COS_IOCTL_RX_IO_UNDER
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32COS_IO_ERROR_IGNORE			0
#define	HPDI32COS_IO_ERROR_CHECK			1
#define	HPDI32COS_IO_ERROR_DEFAULT			HPDI32COS_IO_ERROR_CHECK

//*****************************************************************************
// HPDI32COS_IOCTL_RX_IO_PIO_TRSH
//
//	Parameter:	s32*
//		Pass in any non-negative value, or
//		-1 to read the current setting.
#define	HPDI32COS_IO_PIO_THRESH_DEFAULT		15	// 60 bytes

//*****************************************************************************
// HPDI32COS_IOCTL_RX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	HPDI32COS_IO_TIMEOUT_DEFAULT		10
#define	HPDI32COS_IO_TIMEOUT_NO_SLEEP		0
#define	HPDI32COS_IO_TIMEOUT_MIN			0
#define	HPDI32COS_IO_TIMEOUT_MAX			GSC_IO_TIMEOUT_MAX
#define	HPDI32COS_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// HPDI32COS_IOCTL_RX_START					BCR D5
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32COS_RX_START_NO				0	// default
#define	HPDI32COS_RX_START_YES				1

//*****************************************************************************
// HPDI32COS_IOCTL_RX_STATE					BSR D24, D22
//
//	Parameter:	s32*
//		One of the below options is returned.
#define	HPDI32COS_RX_STATE_DISABLED			0
#define	HPDI32COS_RX_STATE_RUNNING			4
#define	HPDI32COS_RX_STATE_STOPPED			1

//*****************************************************************************
// HPDI32COS_IOCTL_RX_WORD_COUNT			RWCR D0-D31
//
//	Parameter:	u32*
//		The value returned will be in the range of zero through 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_TX_DATA_GET				TDOR D0-D31
//
//	Parameter:	u32*
//		The value returned will be from zero to 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_TX_DATA_SET				TDOR D0-D31
//
//	Parameter:	u32*
//		Pass in any value from zero to 0xFFFFFFFF.

//*****************************************************************************
// HPDI32COS_IOCTL_TX_ENABLE				BCR D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HPDI32COS_TX_ENABLE_NO				0	// default
#define	HPDI32COS_TX_ENABLE_YES				1

//*****************************************************************************
// HPDI32COS_IOCTL_WAIT_EVENT		all fields must be valid
// HPDI32COS_IOCTL_WAIT_CANCEL		fields need not be valid
// HPDI32COS_IOCTL_WAIT_STATUS		fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	HPDI32COS_WAIT_GSC_CC1_RISE			HPDI32COS_IRQ_CC1_RISE
#define	HPDI32COS_WAIT_GSC_CC1_FALL			HPDI32COS_IRQ_CC1_FALL
#define	HPDI32COS_WAIT_GSC_CC2				HPDI32COS_IRQ_CC2
#define	HPDI32COS_WAIT_GSC_CC3				HPDI32COS_IRQ_CC3
#define	HPDI32COS_WAIT_GSC_CC4				HPDI32COS_IRQ_CC4
#define	HPDI32COS_WAIT_GSC_CC5				HPDI32COS_IRQ_CC5
#define	HPDI32COS_WAIT_GSC_CC6				HPDI32COS_IRQ_CC6
#define	HPDI32COS_WAIT_GSC_RX_FIFO_EMPTY	HPDI32COS_IRQ_RX_FIFO_EMPTY
#define	HPDI32COS_WAIT_GSC_RX_FIFO_AE		HPDI32COS_IRQ_RX_FIFO_AE
#define	HPDI32COS_WAIT_GSC_RX_FIFO_AF		HPDI32COS_IRQ_RX_FIFO_AF
#define	HPDI32COS_WAIT_GSC_RX_FIFO_FULL		HPDI32COS_IRQ_RX_FIFO_FULL
#define	HPDI32COS_WAIT_GSC_RX_FIFO_UNDER	HPDI32COS_IRQ_RX_FIFO_UNDER
#define	HPDI32COS_WAIT_GSC_RX_FIFO_OVER		HPDI32COS_IRQ_RX_FIFO_OVER
#define	HPDI32COS_WAIT_GSC_RX_STOPPED		HPDI32COS_IRQ_RX_STOPPED
#define	HPDI32COS_WAIT_GSC_LA_TRIGGERED		HPDI32COS_IRQ_LA_TRIGGERED
#define	HPDI32COS_WAIT_GSC_RX_RUNNING		HPDI32COS_IRQ_RX_RUNNING
#define	HPDI32COS_WAIT_GSC_EVENT_COUNT_0	HPDI32COS_IRQ_EVENT_COUNT_ZERO
#define	HPDI32COS_WAIT_GSC_COS_DETECTED		HPDI32COS_IRQ_COS_DETECTED
#define	HPDI32COS_WAIT_GSC_ALL				HPDI32COS_IRQ_ALL
// gsc_wait_t.alt flags
#define	HPDI32COS_WAIT_ALT_ALL				0x0000
// gsc_wait_t.io
#define	HPDI32COS_WAIT_IO_RX_ABORT			0x0001
#define	HPDI32COS_WAIT_IO_RX_DONE			0x0002
#define	HPDI32COS_WAIT_IO_RX_ERROR			0x0004
#define	HPDI32COS_WAIT_IO_RX_TIMEOUT		0x0008
#define	HPDI32COS_WAIT_IO_ALL				0x000F



// data types *****************************************************************

// Refer to the HPDI32COS_QUERY_FORM_FACTOR option.
typedef enum
{
	HPDI32COS_FORM_FACTOR_UNKNOWN,
	HPDI32COS_FORM_FACTOR_PCI,
	HPDI32COS_FORM_FACTOR_PMC
} hpdi32cos_form_factor_t;

// Refer to the HPDI32COS_QUERY_MODEL option.
typedef enum
{
	HPDI32COS_MODEL_HPDI32A,
	HPDI32COS_MODEL_HPDI32B
} hpdi32cos_model_t;



#endif
