// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/include/hpdi32cos_utils.h $
// $Rev: 54402 $
// $Date: 2024-05-02 09:38:07 -0500 (Thu, 02 May 2024) $

// HPDI32-COS: Utilities: header file

#ifndef	__HPDI32COS_UTILS_H__
#define	__HPDI32COS_UTILS_H__

#include "hpdi32cos_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	hpdi32cos_close_util		(int fd, int index, int verbose);
int hpdi32cos_init_util			(int verbose);
int hpdi32cos_ioctl_util		(int fd, int index, int verbose, int request, void* arg);
int	hpdi32cos_open_util			(int device, int share, int index, int verbose, int* fd);
int	hpdi32cos_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);

// IOCTL utility services

int	hpdi32cos_byte_enable		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_BYTE_ENABLE
int	hpdi32cos_cc_d0_d6_state	(int fd, int index, int verbose,		  s32* get);	// HPDI32COS_IOCTL_CC_D0_D6_STATE
int	hpdi32cos_cc_d5_d6			(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_CC_D5_D6
int	hpdi32cos_clock_divider		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_CLOCK_DIVIDER
int	hpdi32cos_cos_detected		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_COS_DETECTED
int	hpdi32cos_counter_zero		(int fd, int index, int verbose,		  s32* get);	// HPDI32COS_IOCTL_COUNTER_ZERO
int	hpdi32cos_event_count		(int fd, int index, int verbose,		  u32* get);	// HPDI32COS_IOCTL_EVENT_COUNT
int	hpdi32cos_evnt_cnt_ini_get	(int fd, int index, int verbose,		  u32* get);	// HPDI32COS_IOCTL_EVNT_CNT_INI_GET
int	hpdi32cos_evnt_cnt_ini_set	(int fd, int index, int verbose, u32 set);				// HPDI32COS_IOCTL_EVNT_CNT_INI_SET
int	hpdi32cos_fifo_word_count	(int fd, int index, int verbose,		  s32* get);	// HPDI32COS_IOCTL_FIFO_WORD_COUNT
int	hpdi32cos_initialize		(int fd, int index, int verbose);						// HPDI32COS_IOCTL_INITIALIZE
int	hpdi32cos_irq_config_edge	(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_IRQ_CONFIG_EDGE
int	hpdi32cos_irq_config_high	(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_IRQ_CONFIG_HIGH
int	hpdi32cos_irq_enable		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_IRQ_ENABLE
int	hpdi32cos_la_trig_word_get	(int fd, int index, int verbose,		  u32* get);	// HPDI32COS_IOCTL_LA_TRIG_WORD_GET
int	hpdi32cos_la_trig_word_set	(int fd, int index, int verbose, u32 set);				// HPDI32COS_IOCTL_LA_TRIG_WORD_SET
int	hpdi32cos_la_triggered		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_LA_TRIGGERED
int	hpdi32cos_loopback			(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_LOOPBACK
int	hpdi32cos_mode				(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_MODE
int	hpdi32cos_query				(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_QUERY
int	hpdi32cos_reg_mod			(int fd, int index, int verbose, u32 reg, u32 set, u32 mask);	// HPDI32COS_IOCTL_REG_MOD
int	hpdi32cos_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// HPDI32COS_IOCTL_REG_READ
int	hpdi32cos_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// HPDI32COS_IOCTL_REG_WRITE
int	hpdi32cos_rx_data			(int fd, int index, int verbose,		  u32* get);	// HPDI32COS_IOCTL_RX_DATA
int	hpdi32cos_rx_data_mask_get	(int fd, int index, int verbose,		  u32* get);	// HPDI32COS_IOCTL_RX_DATA_MASK_GET
int	hpdi32cos_rx_data_mask_set	(int fd, int index, int verbose, u32 set);				// HPDI32COS_IOCTL_RX_DATA_MASK_SET
int	hpdi32cos_rx_fifo_ae		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_FIFO_AE
int	hpdi32cos_rx_fifo_af		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_FIFO_AF
int	hpdi32cos_rx_fifo_over		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_FIFO_OVER
int	hpdi32cos_rx_fifo_reset		(int fd, int index, int verbose);						// HPDI32COS_IOCTL_RX_FIFO_RESET
int	hpdi32cos_rx_fifo_status	(int fd, int index, int verbose,		  s32* get);	// HPDI32COS_IOCTL_RX_FIFO_STATUS
int	hpdi32cos_rx_fifo_under		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_FIFO_UNDER
int	hpdi32cos_rx_io_abort		(int fd, int index, int verbose,		  s32* get);	// HPDI32COS_IOCTL_RX_IO_ABORT
int	hpdi32cos_rx_io_bmdma_trsh	(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_IO_BMDMA_TRSH
int	hpdi32cos_rx_io_mode		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_IO_MODE
int	hpdi32cos_rx_io_over		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_IO_OVER
int	hpdi32cos_rx_io_pio_trsh	(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_IO_PIO_TRSH
int	hpdi32cos_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_IO_TIMEOUT
int	hpdi32cos_rx_io_under		(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_IO_UNDER
int	hpdi32cos_rx_start			(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_RX_START
int	hpdi32cos_rx_state			(int fd, int index, int verbose,		  s32* get);	// HPDI32COS_IOCTL_RX_STATE
int	hpdi32cos_rx_word_count		(int fd, int index, int verbose,		  u32* get);	// HPDI32COS_IOCTL_RX_WORD_COUNT
int	hpdi32cos_tx_data_get		(int fd, int index, int verbose, u32* get);				// HPDI32COS_IOCTL_TX_DATA_GET
int	hpdi32cos_tx_data_set		(int fd, int index, int verbose, u32 set);				// HPDI32COS_IOCTL_TX_DATA_SET
int	hpdi32cos_tx_enable			(int fd, int index, int verbose, s32 set, s32* get);	// HPDI32COS_IOCTL_TX_ENABLE
int	hpdi32cos_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);		// HPDI32COS_IOCTL_WAIT_CANCEL
int	hpdi32cos_wait_event		(int fd, int index, int verbose, gsc_wait_t* wait);		// HPDI32COS_IOCTL_WAIT_EVENT
int	hpdi32cos_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);		// HPDI32COS_IOCTL_WAIT_STATUS

// Auxiliary utility services

int hpdi32cos_api_listing		(int fd);
int	hpdi32cos_config_cos		(int fd, int index, int verbose);
int	hpdi32cos_config_la			(int fd, int index, int verbose);
int hpdi32cos_id_device			(int fd, int index, int verbose);

int	hpdi32cos_count_boards		(int verbose, s32* get);
int	hpdi32cos_reg_list			(int fd, int detail);

const gsc_reg_def_t*			hpdi32cos_reg_get_def_id(u32 reg);
const gsc_reg_def_t*			hpdi32cos_reg_get_def_index(int index);
const char*						hpdi32cos_reg_get_desc(u32 reg);
const char*						hpdi32cos_reg_get_name(u32 reg);



#endif
