// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/samples/id/perform.c $
// $Rev: 54395 $
// $Date: 2024-05-01 14:53:28 -0500 (Wed, 01 May 2024) $

// HPDI32-COS: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _id_device_reg(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= hpdi32cos_reg_get_def_id(HPDI32COS_GSC_FRR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, hpdi32cos_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. hpdi32cos_reg_get_def_id, HPDI32COS_GSC_FRR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= hpdi32cos_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	for (i = 0; i < HPDI32COS_IOCTL_QUERY_LAST; i++)
		errs	+= hpdi32cos_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_reg(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


