// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/samples/irq/main.h $
// $Rev: 54359 $
// $Date: 2024-04-30 14:55:26 -0500 (Tue, 30 Apr 2024) $

// HPDI32-COS: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdlib.h>
#include <time.h>

#include "hpdi32cos_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	STATUS_NOT_IMPLEMENTED	(-2)
#define	STATUS_NOT_SUPPORTED	(-1)
#define	STATUS_SUPPORTED		(0)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int	cc1_fall_irq_test(int fd, int supported);
int	cc1_rise_irq_test(int fd, int supported);
int	cc2_irq_test(int fd, int supported);
int	cc3_irq_test(int fd, int supported);
int	cc4_irq_test(int fd, int supported);
int	cc5_irq_test(int fd, int supported);
int	cc6_irq_test(int fd, int supported);
int	cos_detected_irq_test(int fd, int supported);

int	event_count_zero_irq_test(int fd, int supported);

int	la_triggered_irq_test(int fd, int supported);

int	main_gsc_irq_test(int fd, int supported);
int	main_dma_irq_test(int fd, int supported);
int	main_pci_irq_test(int fd, int supported);

int	perform_tests(const args_t* args);

int	rx_fifo_ae_irq_test(int fd, int supported);
int	rx_fifo_af_irq_test(int fd, int supported);
int	rx_fifo_empty_irq_test(int fd, int supported);
int	rx_fifo_full_irq_test(int fd, int supported);
int	rx_fifo_over_irq_test(int fd, int supported);
int	rx_fifo_under_irq_test(int fd, int supported);
int	rx_running_irq_test(int fd, int supported);
int	rx_stopped_irq_test(int fd, int supported);



#endif
