// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/samples/rxrate/main.h $
// $Rev: 54399 $
// $Date: 2024-05-01 14:57:30 -0500 (Wed, 01 May 2024) $

// HPDI32-COS: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "hpdi32cos_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	range;			// perform read block size range testing?
	s32	range_inc;		// Incriment range read block size by # bytes.
	s32	range_max;		// End range read block size at # bytes.
	s32	range_min;		// Start range read block size at # bytes.
	s32	rx_mb;			// MB to receive
	s32	save;			// Save the range results to data.txt.
	s32	set_dump;		// Produce a settings dump after each iteration.
	s32	seconds;		// Read data for at least this long.
	s32	test_limit;		// for continuous testing
	int	tests;			// the number of test iterations so far.

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	clock_div;		// Clock Divider
	s32	io_mode;
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
