// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/utils/config_la.c $
// $Rev: 54350 $
// $Date: 2024-04-30 14:45:35 -0500 (Tue, 30 Apr 2024) $

// HPDI32-COS: Utilities: source file

#include "main.h"



//*****************************************************************************
int hpdi32cos_config_la(int fd, int index, int verbose)
{
	int	errs	= 0;

	if (verbose)
	{
		gsc_label_index("LA Configuration", index);
		printf("\n");
		gsc_label_level_inc();
	}

	errs	+= hpdi32cos_initialize			(fd, index, verbose);									// HPDI32COS_IOCTL_INITIALIZE

	// Settings must be applied after the initialization call!
	// Most of these settings are likely suitable for most applications.

	errs	+= hpdi32cos_mode				(fd, index, verbose, HPDI32COS_MODE_LA,			NULL);	// HPDI32COS_IOCTL_MODE
	errs	+= hpdi32cos_irq_enable			(fd, index, verbose, 0,							NULL);	// HPDI32COS_IOCTL_IRQ_ENABLE
	errs	+= hpdi32cos_rx_fifo_ae			(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_FIFO_AE
	errs	+= hpdi32cos_rx_fifo_af			(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_FIFO_AF
	errs	+= hpdi32cos_rx_io_bmdma_trsh	(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_IO_BMDMA_TRSH
	errs	+= hpdi32cos_rx_io_mode			(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_IO_MODE
	errs	+= hpdi32cos_rx_io_over			(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_IO_OVER
	errs	+= hpdi32cos_rx_io_pio_trsh		(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_IO_PIO_TRSH
	errs	+= hpdi32cos_rx_io_timeout		(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_IO_TIMEOUT
	errs	+= hpdi32cos_rx_io_under		(fd, index, verbose, -1,						NULL);	// HPDI32COS_IOCTL_RX_IO_UNDER

	// These particular settings are the ones that most likely must
	// be assigned according to the needs of the application.

	errs	+= hpdi32cos_clock_divider		(fd, index, verbose, 0,							NULL);	// HPDI32COS_IOCTL_CLOCK_DIVIDER
	errs	+= hpdi32cos_evnt_cnt_ini_set	(fd, index, verbose, 0);								// HPDI32COS_IOCTL_EVNT_CNT_INI_SET
	errs	+= hpdi32cos_la_trig_word_set	(fd, index, verbose, 0);								// HPDI32COS_IOCTL_LA_TRIG_WORD_SET
	errs	+= hpdi32cos_rx_data_mask_set	(fd, index, verbose, 0);								// HPDI32COS_IOCTL_RX_DATA_MASK_SET

	// Start collecting data.

	errs	+= hpdi32cos_rx_start			(fd, index, verbose, HPDI32COS_RX_START_YES,	NULL);	// HPDI32COS_IOCTL_RX_START

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}


