// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/utils/evnt_cnt_ini_set.c $
// $Rev: 54350 $
// $Date: 2024-04-30 14:45:35 -0500 (Tue, 30 Apr 2024) $

// HPDI32-COS: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hpdi32cos_evnt_cnt_ini_set
*
*	Purpose:
*
*		Provide a visual wrapper for the HPDI32COS_IOCTL_EVNT_CNT_INI_SET service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely? 0 = no, !0 = yes
*
*		set		This is the value to apply.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hpdi32cos_evnt_cnt_ini_set(int fd, int index, int verbose, u32 set)
{
	char	buf[128];
	int		errs;
	s32		ret;

	if (verbose)
		gsc_label_index("Event Count Init Set", index);

	ret		= hpdi32cos_ioctl(fd, HPDI32COS_IOCTL_EVNT_CNT_INI_SET, &set);
	errs	= ret ? 1 : 0;
	gsc_label_long_comma_buf(set, buf);

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	return(errs);
}


