// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/utils/rx_fifo_reset.c $
// $Rev: 54350 $
// $Date: 2024-04-30 14:45:35 -0500 (Tue, 30 Apr 2024) $

// HPDI32-COS: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hpdi32cos_rx_fifo_reset
*
*	Purpose:
*
*		Provide a visual wrapper for the HPDI32COS_IOCTL_RX_FIFO_RESET service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely? 0 = no, !0 = yes
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hpdi32cos_rx_fifo_reset(int fd, int index, int verbose)
{
	int	errs;
	s32	ret;

	if (verbose)
		gsc_label_index("Rx FIFO Reset", index);

	ret		= hpdi32cos_ioctl(fd, HPDI32COS_IOCTL_RX_FIFO_RESET, NULL);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


