// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/HPDI32-COS/HPDI32-COS-1.x_GSC_DN/utils/rx_word_count.c $
// $Rev: 54350 $
// $Date: 2024-04-30 14:45:35 -0500 (Tue, 30 Apr 2024) $

// HPDI32-COS: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hpdi32cos_rx_word_count
*
*	Purpose:
*
*		Provide a visual wrapper for the HPDI32COS_IOCTL_RX_WORD_COUNT service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely? 0 = no, !0 = yes
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int hpdi32cos_rx_word_count(int fd, int index, int verbose, u32* get)
{
	char	buf[128];
	int		errs;
	s32		ret;
	u32		set;

	if (verbose)
		gsc_label_index("Rx Words Received", index);

	ret		= hpdi32cos_ioctl(fd, HPDI32COS_IOCTL_RX_WORD_COUNT, &set);
	errs	= ret ? 1 : 0;
	gsc_label_long_comma_buf(set, buf);

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


